cascading.flow.stream.graph

## Class StreamGraph

- java.lang.Object
- - cascading.flow.stream.graph.StreamGraph

- Direct Known Subclasses:
    NodeStreamGraph

      public class StreamGraph
      extends java.lang.Object

  Class StreamGraph is the operation pipeline used during processing. This an internal use only class.

  Under some circumstances it may make sense to see the actual graph plan. To do so, enable one or both dot file properties, `ERROR_DOT_FILE_NAME` and `DOT_FILE_PATH`.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `DOT_FILE_PATH` Property denoting the path to write all stream graph dot files.
    `static java.lang.String` | `ERROR_DOT_FILE_NAME` Property denoting the path and filename to write the failed stream graph dot file.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `StreamGraph()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addHead(Duct head)`
    `void` | `addPath(Duct lhs, Duct rhs)`
    `void` | `addPath(Duct lhs, int ordinal, Duct rhs)`
    `void` | `addTail(Duct tail)`
    `void` | `bind()`
    `void` | `cleanup()` Calls cleanup starting at the head and working forwards
    `protected Duct` | `createCloseWindow(Duct next)`
    `protected Duct` | `createFork(Duct[] allNext)`
    `Duct` | `createNextFor(Duct current)`
    `protected Duct` | `createOpenReducingWindow(Duct next)`
    `protected Duct` | `createOpenWindow(Duct next)`
    `Duct[]` | `findAllNextFor(Duct current)`
    `Duct[]` | `findAllPreviousFor(Duct current)`
    `java.util.Collection<Duct>` | `getAllDucts()`
    `java.util.Collection<Duct>` | `getHeads()`
    `protected java.lang.Object` | `getProperty(java.lang.String name)`
    `org.jgrapht.DirectedGraph` | `getReversedGraph()`
    `org.jgrapht.traverse.TopologicalOrderIterator<Duct,java.lang.Integer>` | `getReversedTopologicalOrderIterator()`
    `java.util.Collection<Duct>` | `getTails()`
    `org.jgrapht.traverse.TopologicalOrderIterator<Duct,java.lang.Integer>` | `getTopologicalOrderIterator()`
    `int` | `ordinalBetween(Duct lhs, Duct rhs)`
    `void` | `prepare()` Calls prepare starting at the tail and working backwards
    `void` | `printBoundGraph(java.lang.String filename)`
    `void` | `printBoundGraph(java.lang.String id, java.lang.String classifier, int discriminator)`
    `void` | `printGraph(java.lang.String filename)`
    `void` | `printGraph(java.lang.String id, java.lang.String classifier, int discriminator)`
    `void` | `printGraphError()`
    `protected Duct` | `wrapWithOrdinal(DuctGraph.Ordinal edge, Duct next)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### ERROR_DOT_FILE_NAME

          public static final java.lang.String ERROR_DOT_FILE_NAME

      Property denoting the path and filename to write the failed stream graph dot file.
      See Also:
        Constant Field Values

    - #### DOT_FILE_PATH

          public static final java.lang.String DOT_FILE_PATH

      Property denoting the path to write all stream graph dot files. The filename will be generated based on platform properties.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### StreamGraph

          public StreamGraph()

  - ### Method Detail

    - #### getProperty

          protected java.lang.Object getProperty(java.lang.String name)

    - #### addHead

          public void addHead(Duct head)

    - #### addTail

          public void addTail(Duct tail)

    - #### addPath

          public void addPath(Duct lhs,
                     Duct rhs)

    - #### addPath

          public void addPath(Duct lhs,
                     int ordinal,
                     Duct rhs)

    - #### bind

          public void bind()

    - #### prepare

          public void prepare()

      Calls prepare starting at the tail and working backwards

    - #### cleanup

          public void cleanup()

      Calls cleanup starting at the head and working forwards

    - #### getHeads

          public java.util.Collection<Duct> getHeads()

    - #### getTails

          public java.util.Collection<Duct> getTails()

    - #### findAllNextFor

          public Duct[] findAllNextFor(Duct current)

    - #### findAllPreviousFor

          public Duct[] findAllPreviousFor(Duct current)

    - #### createNextFor

          public Duct createNextFor(Duct current)

    - #### wrapWithOrdinal

          protected Duct wrapWithOrdinal(DuctGraph.Ordinal edge,
                             Duct next)

    - #### createCloseWindow

          protected Duct createCloseWindow(Duct next)

    - #### createOpenWindow

          protected Duct createOpenWindow(Duct next)

    - #### createOpenReducingWindow

          protected Duct createOpenReducingWindow(Duct next)

    - #### createFork

          protected Duct createFork(Duct[] allNext)

    - #### ordinalBetween

          public int ordinalBetween(Duct lhs,
                           Duct rhs)

    - #### getTopologicalOrderIterator

          public org.jgrapht.traverse.TopologicalOrderIterator<Duct,java.lang.Integer> getTopologicalOrderIterator()

    - #### getReversedTopologicalOrderIterator

          public org.jgrapht.traverse.TopologicalOrderIterator<Duct,java.lang.Integer> getReversedTopologicalOrderIterator()

    - #### getReversedGraph

          public org.jgrapht.DirectedGraph getReversedGraph()

    - #### getAllDucts

          public java.util.Collection<Duct> getAllDucts()

    - #### printGraphError

          public void printGraphError()

    - #### printGraph

          public void printGraph(java.lang.String id,
                        java.lang.String classifier,
                        int discriminator)

    - #### printGraph

          public void printGraph(java.lang.String filename)

    - #### printBoundGraph

          public void printBoundGraph(java.lang.String id,
                             java.lang.String classifier,
                             int discriminator)

    - #### printBoundGraph

          public void printBoundGraph(java.lang.String filename)

Copyright © 2007-2015 Xplenty, Inc. All Rights Reserved.